#include <stdio.h>
#include <sys/types.h>
#include <pwd.h>
#include <sys/stat.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <netdb.h>

#ifdef ultrix
char *strdup(s)
char *s;
{
    char *ret;

    if (ret = malloc(strlen(s) + 1))
	strcpy(ret, s);
    return (ret);
}
#endif

struct xx {
	char *prezime;
	char *username;
	char *name;
#ifndef IGNORE_OFFICE
	char *office;
#endif
};

#ifndef MYHOSTNAME

struct hostent *
myhostname(hostbuf, size)
	char hostbuf[];
	int size;
{
	register struct hostent *hp;

	if (gethostname(hostbuf, size) < 0)
	{
		(void) strcpy(hostbuf, "localhost");
	}
	hp = gethostbyname(hostbuf);
	if (hp == NULL)
		return NULL;
	if (strchr(hp->h_name, '.') != NULL || strchr(hostbuf, '.') == NULL)
	{
		(void) strncpy(hostbuf, hp->h_name, size - 1);
		hostbuf[size - 1] = '\0';
	}

	if (strchr(hostbuf, '.') == NULL)
	{
		char **ha;

		for (ha = hp->h_aliases; *ha != NULL; ha++)
		{
			if (strchr(*ha, '.') != NULL)
			{
				(void) strncpy(hostbuf, *ha, size - 1);
				hostbuf[size - 1] = '\0';
				break;
			}
		}
	}
	return (hp);
}

#endif

int compare (const void *X1, const void *X2)
{
	int rez;
	struct xx *x1 = (struct xx *) X1, *x2 = (struct xx *) X2;

	rez = strcasecmp (x1->prezime, x2->prezime);
	if (rez != 0) return rez;
	else return strcasecmp (x1->name, x2->name);
}

main (int argc, char **argv)
{
	struct passwd *pw;
	char name[512], *p, *q, in['Z'-'A'+1], *pp;
	struct stat st;
	struct xx users[4000];
	int n = 0, i, ch = 0, lett = 0;
	char hostname[256];

	if (argc > 1) lett = toupper (*argv[1]);
	else for (i='A'-'A'; i<='Z'-'A'; in[i++] = 0);

#ifndef MYHOSTNAME
	myhostname (hostname, sizeof(hostname));
#else
	strcpy (hostname, MYHOSTNAME);
#endif

	printf ("Content-type: text/html\n\n");
#ifdef OLD_VERSION
	printf ("<html><head><title>Personal home pages on %s</title></head>\n", hostname);
	printf ("<body><center><h2>Personal home pages on %s</h2>\n", hostname);
#else
	printf ("<html><head><title>Osobne stranice na racunalu %s</title></head>\n", hostname);
	printf ("<body><center><h2>Osobne stranice na racunalu %s</h2>\n", hostname);
	printf ("<h2>Personal home pages on %s</h2>\n", hostname);
#endif
	setpwent ();
	while ((pw = getpwent()) != NULL) {
		p = strchr (pw->pw_gecos, '-');
		while ((p != NULL) && ((p[-1] != ' ') || (p[1] != ' ')))
			p = strchr (p+1, '-');
		if (p == NULL) {
			p = strchr (pw->pw_gecos, ',');
			if (p == NULL) p = "";
			else *p++ = '\0';
		}
		else {
			p[-1] = '\0';
			p = p+2;
		}
		q = strrchr (pw->pw_gecos, ' ');
		q  = (q == NULL)  ? pw->pw_gecos : (q+1);
		if ((lett != 0) && (lett != toupper (*q))) continue;

		sprintf (name, "%s/public_html", pw->pw_dir);
		if (stat (name, &st) < 0) continue;
		pp = name + strlen (name);
		strcpy (pp, "/index.html");
		if ((stat (name, &st) < 0) && (errno != ENOENT)) {
			continue;
		}
		strcpy (pp, "/.hide");
		if (stat (name, &st) >= 0) {
			continue;
		}
		users[n].prezime = strdup (q);
		in[toupper(*q)-'A'] = 1;
		users[n].username = strdup (pw->pw_name);
#ifndef IGNORE_OFFICE
		users[n].office = strdup (p);
#endif
		users[n++].name = strdup (pw->pw_gecos);
	}
	endpwent ();
	qsort (users, n, sizeof(struct xx), compare);
	if (lett == 0) {
		printf ("<h2>");
		for (i='A'; i<='Z'; ++i)
			if (in[i-'A'])
				printf ("<A HREF=\"#%c\">%c </A>\n", i, i);
		printf ("</h2>");
	}
	printf ("</center>");
	printf ("<table>");
	for (i=0; i<n; ++i) {
		if (ch != toupper(users[i].prezime[0])) {
			ch = toupper(users[i].prezime[0]);
			printf ("</table><p><hr><ul><h1><b><A NAME=\"%c\">%c</a></b></h1></ul><table>\n",
				ch, ch);
		}

#ifndef IGNORE_OFFICE
		printf (
		"<tr><td><A HREF=\"http://%s/~%s\">%s</a> </td><td> - </td><td><B>%s</b>%s%s</td></tr>\n",
			hostname,
			users[i].username,
			users[i].username,
			users[i].name,
			(users[i].office[0] == '\0') ? "" : ", ",
			users[i].office);
		free (users[i].office);
#else
		printf (
		"<tr><td><A HREF=\"http://%s/~%s\">%s</a> </td><td> - </td><td><B>%s</b></td></tr>\n",
			hostname,
			users[i].username,
			users[i].username,
			users[i].name);
#endif
		free (users[i].prezime);
		free (users[i].username);
		free (users[i].name);
	}
	puts ("</table><p><hr></body></html>");
}
